/// @cond EO_CXX_EO_IMPL

inline void elm::grid::clear(bool clear_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_grid_clear(::efl::eolian::to_c(clear_)));
}

inline void elm::grid::unpack(::evas::object subobj_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_grid_unpack(::efl::eolian::to_c(subobj_)));
}

inline void elm::grid::pack(::evas::object subobj_, Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_grid_pack(::efl::eolian::to_c(subobj_), x_, y_, w_, h_));
}

inline void elm::grid::size_get(Evas_Coord* w_, Evas_Coord* h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_grid_size_get(w_, h_));
}

inline void elm::grid::size_set(Evas_Coord w_, Evas_Coord h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_grid_size_set(w_, h_));
}

inline ::efl::eina::list< ::evas::object > elm::grid::children_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_grid_children_get());
   return ::efl::eolian::to_cxx<::efl::eina::list< ::evas::object >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
}

inline void eo_cxx::elm::grid::clear(bool clear_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_grid_clear(::efl::eolian::to_c(clear_)));
}

inline void eo_cxx::elm::grid::unpack(::evas::object subobj_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_grid_unpack(::efl::eolian::to_c(subobj_)));
}

inline void eo_cxx::elm::grid::pack(::evas::object subobj_, Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_grid_pack(::efl::eolian::to_c(subobj_), x_, y_, w_, h_));
}

inline void eo_cxx::elm::grid::size_get(Evas_Coord* w_, Evas_Coord* h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_grid_size_get(w_, h_));
}

inline void eo_cxx::elm::grid::size_set(Evas_Coord w_, Evas_Coord h_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_grid_size_set(w_, h_));
}

inline ::efl::eina::list< ::evas::object > eo_cxx::elm::grid::children_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_grid_children_get());
   return ::efl::eolian::to_cxx<::efl::eina::list< ::evas::object >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
}

inline ::eo_cxx::elm::grid::operator ::elm::grid() const
{
   return *static_cast<::elm::grid const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::grid::operator ::elm::grid&()
{
   return *static_cast<::elm::grid*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::grid::operator ::elm::grid const&() const
{
   return *static_cast<::elm::grid const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_grid_clear_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool clear_)
{
   try
      {
         static_cast<T*>(self->this_)->clear(::efl::eolian::to_cxx<bool>(clear_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_grid_unpack_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * subobj_)
{
   try
      {
         static_cast<T*>(self->this_)->unpack(::efl::eolian::to_cxx<::evas::object>(subobj_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_grid_pack_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Object * subobj_, Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
{
   try
      {
         static_cast<T*>(self->this_)->pack(::efl::eolian::to_cxx<::evas::object>(subobj_, std::tuple<std::false_type>()), x_, y_, w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_grid_size_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord* w_, Evas_Coord* h_)
{
   try
      {
         static_cast<T*>(self->this_)->size_get(w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_grid_size_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Evas_Coord w_, Evas_Coord h_)
{
   try
      {
         static_cast<T*>(self->this_)->size_set(w_, h_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::list< ::evas::object > elm_grid_children_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->children_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::list< ::evas::object >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::grid >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::widget >::template type<T>
   {
      virtual void clear(bool clear_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_grid_clear(::efl::eolian::to_c(clear_)));
      }

      virtual void unpack(::evas::object subobj_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_grid_unpack(::efl::eolian::to_c(subobj_)));
      }

      virtual void pack(::evas::object subobj_, Evas_Coord x_, Evas_Coord y_, Evas_Coord w_, Evas_Coord h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_grid_pack(::efl::eolian::to_c(subobj_), x_, y_, w_, h_));
      }

      virtual void size_get(Evas_Coord* w_, Evas_Coord* h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_grid_size_get(w_, h_));
      }

      virtual void size_set(Evas_Coord w_, Evas_Coord h_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_grid_size_set(w_, h_));
      }

      virtual ::efl::eina::list< ::evas::object > children_get()
      {
         Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_grid_children_get());
            return ::efl::eolian::to_cxx<::efl::eina::list< ::evas::object >>(_tmp_ret, std::tuple<std::true_type, std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::grid >
{
   static constexpr int value = 
#if defined(GRID_PROTECTED) && defined(GRID_BETA)
      6
#elif defined(GRID_PROTECTED)
      6
#elif defined(GRID_BETA)
      6
#else
      6
#endif
      + operation_description_class_size<::elm::widget >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::grid>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_grid_clear_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_grid_clear);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_grid_unpack_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_grid_unpack);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_grid_pack_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_grid_pack);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_grid_size_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_grid_size_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_grid_size_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_grid_size_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_grid_children_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_grid_children_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::widget>(), &ops[operation_description_class_size< ::elm::grid >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::grid>)
{
   return (ELM_GRID_CLASS);
}

} } }

/// @endcond

